#include <stdarg.h>
#include <stdio.h>

#include "sz.h"
#define WEB_PRIVATE
#include "web.h"

static webtype web_none[] = { WT_NONE };

static webtype web_plaintext[] = { WT_TEXT, WT_NONE };

static webtype web_text[] = {
	WT_TEXT, WT_B, WT_I, WT_TT, WT_CITE, WT_EM, WT_STRONG, WT_NONE
};

static webtype web_head[] = {
	WT_TITLE, WT_NONE
};

static webtype web_html[] = {
	WT_HEAD, WT_BODY, WT_NONE
};

static webtype web_list[] = {
	WT_LI, WT_NONE
};

static webtype web_dlist[] = {
	WT_DT, WT_DD, WT_NONE
};

static webtype web_body[] = {
	WT_P,
	WT_H1, WT_H2, WT_H3,
	WT_H4, WT_H5, WT_H6,
	WT_TABLE,
	WT_NONE
};

static webtype web_table[] = { WT_TR, WT_NONE };
static webtype web_trow[] = { WT_TD, WT_NONE };

struct webinfo web_info[WT_MAX] = {
	{ "NONE", "NONE", 0, 0 },
	{ "RAW", 0, 0, web_none },
	{ "CAT", 0, 0, 0 },
	{ "HTML", "HTML", 0, web_html },
	{ "HEAD", "HEAD", 0, web_head },
	{ "TITLE", "TITLE", 0, web_plaintext },
	{ "BODY", "BODY", 0, web_body },
	{ "H1", "H1", 0, web_text }, { "H2", "H2", 0, web_text },
	{ "H3", "H3", 0, web_text }, { "H4", "H4", 0, web_text },
	{ "H5", "H5", 0, web_text }, { "H6", "H6", 0, web_text },
	{ "PRE", "PRE", 0, web_plaintext },
	{ "TEXT", "TEXT", 0, web_none },
	{ "P", "P", 0, web_text },
	{ "B", "B", 0, web_text },
	{ "I", "I", 0, web_text },
	{ "TT", "TT", 0, web_text },
	{ "EM", "EM", 0, web_text },
	{ "STRONG", "STRONG", 0, web_text },
	{ "CITE", "CITE", 0, web_text },
	{ "CODE", "CODE", 0, web_text },
	{ "SAMP", "SAMP", 0, web_text },
	{ "KEYBOARD", "KEYBOARD", 0, web_text },
	{ "OL", "OL", 0, web_list },
	{ "UL", "UL", 0, web_list },
	{ "DL", "DL", 0, web_dlist },
	{ "LI", "LI", WF_NOCLOSE, web_body },
	{ "DT", "DT", 0, web_text },
	{ "DD", "DD", 0, web_text },
	{ "TABLE", "TABLE", 0, web_table },
	{ "TR", "TR", 0, web_trow },
	{ "TD", "TD", 0, web_body },
	{ "HR", "HR", WF_NOCLOSE, web_none },
	{ "BR", "BR", WF_NOCLOSE, web_none }
};
