#ifndef WEB_H
#define WEB_H

#define WEB_MAGIC 0x03

typedef struct web web;

#define WEBNULL ((void *) 0)

typedef enum webtype {
	WT_NONE,
	WT_RAW,
	WT_CAT,
	WT_HTML, WT_HEAD, WT_TITLE, WT_BODY,
	WT_H1, WT_H2, WT_H3, WT_H4, WT_H5, WT_H6,
	WT_PRE,
	WT_TEXT,
	WT_P,
	WT_B, WT_I, WT_TT,
	WT_EM, WT_STRONG, WT_CITE,
	WT_CODE, WT_SAMP, WT_KEYBOARD,
	WT_OL, WT_UL,
	WT_LI,
	WT_DL, WT_DT, WT_DD,
	WT_TABLE, WT_TR, WT_TD,
	WT_BR, WT_HR,
	WT_MAX
} webtype;

extern web	*webnew(void);
extern web	*webpage(void *, ...);
extern web	*webtable(void *, ...);
extern web	*webmake(void *, void *, ...);
extern web	*webconcat(void *, ...);
extern web	*webcat(void *, ...);
extern web	*webraw(void *);
extern web	*webvmake(void *, void *, va_list);
extern void	 websetattr(web *, void *, ...);
extern void	 webfprint(FILE *, web *);
extern void	 webfdebug(FILE *, web *);
extern void	 webinsert(web *, void *);
extern void	 webfree(web *);
extern sz	*webencode(void *);

#ifdef WEB_PRIVATE

enum webinfoflags {
	WF_NONE = 0,
	WF_NOCLOSE = 0x1
};

typedef struct webinfo webinfo;

struct webinfo {
	char *name;
	char *spelling;
	int flags;
	webtype *contains;
};

extern struct webinfo web_info[];
#endif

#endif
